CREATE TABLE "user" (
    "id"                        UUID NOT NULL PRIMARY KEY,
    "createdAt"                 TIMESTAMPTZ DEFAULT now(),
    "updatedAt"                 TIMESTAMPTZ DEFAULT now(),
    "identifier"                TEXT UNIQUE NOT NULL,
    "levelMin"                  INT DEFAULT 1,
    "level"                     INT NOT NULL,
    "level_browser"             JSONB,
    "quiz.settings"             JSONB
);

CREATE TRIGGER "t_user_updatedAt"
    BEFORE UPDATE ON "user"
    FOR EACH ROW
    EXECUTE PROCEDURE "f_updatedAt"();

CREATE INDEX "idx_user_updatedAt" ON "user" ("updatedAt");
CREATE INDEX "idx_user_identifier" ON "user" ("identifier");

INSERT INTO "user" ("id", "identifier", "level") VALUES
(uuid_nil(), '', 1),
('00000000-0000-0000-0000-000000000001', 'wanikani', 1);
