CREATE TABLE "quiz.preset" (
    "id"              UUID NOT NULL PRIMARY KEY DEFAULT uuid_generate_v4(),
    "createdAt"       TIMESTAMPTZ DEFAULT now(),
    "updatedAt"       TIMESTAMPTZ DEFAULT now(),
    "userId"          UUID NOT NULL REFERENCES "user"("id") ON DELETE CASCADE,
    "name"            TEXT NOT NULL,
    "settings"        JSONB NOT NULL
);

CREATE TRIGGER "t_quiz.preset_updatedAt"
    BEFORE UPDATE ON "quiz.preset"
    FOR EACH ROW
    EXECUTE PROCEDURE "f_updatedAt"();

CREATE INDEX "idx_quiz.preset_updatedAt" ON "quiz.preset" ("updatedAt");
CREATE INDEX "idx_quiz.preset_userId" ON "quiz.preset" ("userId");
CREATE INDEX "idx_quiz.preset_name" ON "quiz.preset"
    USING pgroonga ("name");
